
s = [=[
 ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz.,:;'"?/\[](){}<>1234567890!@#$%^&*_-+=~`|]=]
s = s.."\t"

local G, W, H
local sz = 2

world = nil
entities = {}

Box = {}
function Box:new(o)
	o = o or {}
	setmetatable(o,self)
	self.__index = self
	o.w = 32
	o.h = 32
	o.body = love.physics.newBody(world,o.x,o.y,"dynamic")
	local s = love.physics.newRectangleShape(o.w,o.h)
	local f = love.physics.newFixture(o.body, s, 1)
	f:setFriction(0.8)
	f:setRestitution(0)
	self.shape = s
	o.body:resetMassData()
	o.color = math.random(1,#colors)
	return o
end

function Box:draw()
	G.push()
	local x,y = self.body:getPosition()
	local a = self.body:getAngle()
	G.translate(x,y)
	G.rotate(a)
	G.setColor(unpack(colors[self.color],1,3))
	G.drawq(img, diffuse, -self.w*1.2/2, -self.h*1.2/2, 0, 1.2, 1.2)
	G.polygon("line",self.body:getWorldPoints(self.shape:getPoints()))
	--G.drawq(img, diffuse, x-self.w*1.2/2, y-self.h*1.2/2, a, 1.2,1.2)
	G.pop()
end

function love.load ()
	G = love.graphics
	W = G.getWidth
	H = G.getHeight
	G.setCaption "Boxen GLSL Lighting Test"
	G.setBackgroundColor(35, 30, 65)

	ao_toggle = 1 -- ao_toggle starts on
	z = 30
	time = 0
	angle = 0

	G.setDefaultImageFilter("linear", "linear")
	img = G.newImage "box.png"
	diffuse  = G.newQuad(0, 0, 32, 32, 96, 32)

	effect = G.newPixelEffect "shader.glsl"
	--effect:send("ao_toggle", ao_toggle)

	world = love.physics.newWorld(0,9.81*64,true)
	love.physics.setMeter(64)
	local ground = love.physics.newBody(world,W()/2,H(),"static")
	love.physics.newFixture(ground,love.physics.newRectangleShape(W(),64))
end

colors = {
	{ 198, 45, 66 },  -- red
	{ 141, 78, 133 }, -- purple
	{ 23, 172, 120 }, -- green
	{ 255, 207, 72 }, -- yellow
	{ 46, 88, 148 }, -- blue
}

function love.update (dt)
	time = time + dt
	world:update(dt)
	--z = z + math.cos(time)/3

	local x, y = love.mouse.getPosition()
	x = x
	y = H()-y
	angle = angle + dt * 0.1
	mouse = {x=x, y=y}
	effect:send("light_pos", {x, y, z})
end

function love.mousepressed (x,y,button)
	if button == "l" then
	   --ao_toggle = (ao_toggle + 1)%2
	   --effect:send("ao_toggle", ao_toggle)
	   table.insert(entities,Box:new({x=x,y=y}))
	elseif button == "wd" then
	   z = z - 1
	elseif button == "wu" then
	   z = z + 1
	end
end

function love.draw ()
	--canvas:clear()
	--G.setCanvas(canvas)
	draw()
	--G.setCanvas()
	--G.setPixelEffect()
	--G.draw(canvas, 0, 0, 0, sz, sz)
end

function printf (...)
	G.print(string.format(...), 20, 10)
end

function draw ()
	G.setPixelEffect(effect)
	for i,ent in ipairs(entities) do
	   ent:draw()
	end
	G.setPixelEffect()
end
