extern vec3 light_pos;

vec4 effect(vec4 color, Image texture, vec2 texture_coords, vec2 pixel_coords) {
	
	vec4 diffuse  = Texel(texture, texture_coords) * color;
	vec4 channels = Texel(texture, texture_coords + vec2(0.66667, 0));
	float ao = channels.r;
	float bypass = channels.g;

	vec3 normal  = Texel(texture, texture_coords + vec2(0.3333, 0)).rgb;
	normal.y = 1 - normal.y;
	normal = normalize(mix(vec3(-1), vec3(1), normal));
	mat4 toWorldSpace = gl_ModelViewMatrix;
	vec4 n = vec4(normal.x,normal.y,normal.z,0);
	n = n * toWorldSpace;
	normal = vec3(n.x,n.y,n.z);
	normal = normalize(normal);

	vec3 light_direction = light_pos - vec3(pixel_coords, 0);
	float light_distance = length(light_direction);
	float attenuation = 1000000/pow(light_distance, 2);
	//float attenuation = 1000000;
	light_direction = normalize(light_direction);
	float light = clamp(attenuation * dot(normal, light_direction), 0.0, 1.0);
   light = light * (0.4 + ao*0.6);
	light *= bypass;

	vec3 dark_color = vec3(0.1, 0.1, 0.5);
	vec3 light_color = vec3(.0, .0, .0);
	vec3 gooch_light = mix(dark_color, light_color, light) * 0.5;
	gooch_light *= bypass;

	float cel_light = smoothstep(0.3, 0.7, light)*0.6 + 0.4;

	return vec4(cel_light * diffuse.rgb + gooch_light, diffuse.a);
}
